"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactImmutableProptypes = _interopRequireDefault(require("react-immutable-proptypes"));

var _uiIcons = require("@instructure/ui-icons");

var _uiA11y = require("@instructure/ui-a11y");

var _uiLayout = require("@instructure/ui-layout");

var _uiElements = require("@instructure/ui-elements");

var _uiThemeable = require("@instructure/ui-themeable");

var _ContextualButton = require("../ContextualButton");

var _ContextualDeprecatedSelect = require("../ContextualDeprecatedSelect");

var _theme = _interopRequireDefault(require("./theme"));

var _quizCommon = require("@instructure/quiz-common");

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _dec, _class, _class2, _temp;

var styles = {
  componentId: 'edByO',
  template: function template(theme) {
    return "\n\n.edByO_bqPU{text-decoration:line-through}";
  },
  'labelRemoved': 'edByO_bqPU'
};
var PeopleList = (_dec = (0, _uiThemeable.themeable)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(PeopleList, _Component);

  function PeopleList() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, PeopleList);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(PeopleList)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.handlePersonRemove = function (e, _ref) {
      var person = _ref.person,
          isPersonRemoved = _ref.isPersonRemoved;

      _this.props.onPersonRemove(person.get('id'), isPersonRemoved);
    };

    _this.handlePermissionChange = function (event, selectedOption, index) {
      _this.props.onPermissionChange(index, event.target.value);
    };

    _this.removeButton = function (person, isPersonRemoved) {
      var context = {
        person: person,
        isPersonRemoved: isPersonRemoved
      };
      return _react.default.createElement(_ContextualButton.ContextualButton, {
        context: context // eslint-disable-next-line react/jsx-no-literals
        ,
        "data-automation": "sdk-unshare-bank-user-".concat(person.get('userUuid')),
        variant: "icon",
        onClick: _this.handlePersonRemove,
        icon: isPersonRemoved ? _uiIcons.IconResetLine : _uiIcons.IconTrashLine
      }, _react.default.createElement(_uiA11y.ScreenReaderContent, null, isPersonRemoved ? (0, _formatMessage.default)('Undo remove for {person}', {
        person: person.get('fullName')
      }) : (0, _formatMessage.default)('Remove {person}', {
        person: person.get('fullName')
      })));
    };

    _this.renderPerson = function (person, index) {
      var isPersonRemoved = _this.props.peopleToRemove.includes(person.get('id'));

      return _react.default.createElement(_uiLayout.Grid.Row, {
        key: person.get('userUuid'),
        "data-automation": "sdk-shared-with-user-row"
      }, _react.default.createElement(_uiLayout.Grid.Col, {
        width: 1
      }, _react.default.createElement(_uiElements.Avatar, {
        name: person.get('fullName'),
        src: person.get('avatar'),
        size: "small"
      })), _react.default.createElement(_uiLayout.Grid.Col, null, _react.default.createElement("span", {
        className: isPersonRemoved ? styles.labelRemoved : null,
        "data-automation": isPersonRemoved ? 'sdk-shared-user-removed' : null
      }, person.get('fullName'))), false && _react.default.createElement(_uiLayout.Grid.Col, {
        width: "auto"
      }, _react.default.createElement(_ContextualDeprecatedSelect.ContextualDeprecatedSelect, {
        context: index,
        onChange: _this.handlePermissionChange,
        value: person.get('permission'),
        label: _react.default.createElement(_uiA11y.ScreenReaderContent, null, (0, _formatMessage.default)('Access for {person}', {
          person: person.get('fullName')
        }))
      }, _react.default.createElement("option", {
        value: _quizCommon.CAN_EDIT
      }, (0, _formatMessage.default)('Can edit')), _react.default.createElement("option", {
        value: _quizCommon.READ_ONLY
      }, (0, _formatMessage.default)('Read only')))), _react.default.createElement(_uiLayout.Grid.Col, {
        width: "auto"
      }, _this.props.people.size === 1 ? null : _this.removeButton(person, isPersonRemoved)));
    };

    return _this;
  }

  (0, _createClass2.default)(PeopleList, [{
    key: "render",
    value: function render() {
      var people = this.props.people;
      return _react.default.createElement("div", null, _react.default.createElement(_uiElements.Text, {
        as: "div",
        weight: "bold"
      }, (0, _formatMessage.default)('Currently shared with')), _react.default.createElement(_uiLayout.View, {
        as: "div",
        padding: "small 0 0 0",
        "data-automation": "sdk-shared-bank-user-list"
      }, _react.default.createElement(_uiLayout.Grid, {
        vAlign: "middle"
      }, people.map(this.renderPerson))));
    }
  }]);
  PeopleList.displayName = "PeopleList";
  return PeopleList;
}(_react.Component), _class2.propTypes = {
  people: _reactImmutableProptypes.default.listOf(_reactImmutableProptypes.default.contains({
    avatar: _propTypes.default.string,
    fullName: _propTypes.default.string.isRequired,
    userUuid: _propTypes.default.string.isRequired,
    permission: _propTypes.default.string.isRequired,
    id: _propTypes.default.string.isRequired
  })).isRequired,
  onPermissionChange: _propTypes.default.func.isRequired,
  onPersonRemove: _propTypes.default.func.isRequired,
  peopleToRemove: _propTypes.default.arrayOf(_propTypes.default.string).isRequired
}, _temp)) || _class);
exports.default = PeopleList;