"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.addQuizEntries = addQuizEntries;
exports.addQuizEntry = addQuizEntry;
exports.deleteQuizEntry = deleteQuizEntry;
exports.deleteStimulusEntry = deleteStimulusEntry;
exports.moveQuizEntry = moveQuizEntry;

var _quizCommon = require("@instructure/quiz-common");

function addQuizEntries(quizEntries) {
  return {
    type: _quizCommon.ADD_QUIZ_ENTRIES,
    payload: quizEntries
  };
}

function addQuizEntry(quizEntry) {
  return {
    type: _quizCommon.ADD_QUIZ_ENTRY,
    payload: quizEntry
  };
}

function deleteQuizEntry(id) {
  return {
    type: _quizCommon.DELETE_QUIZ_ENTRY,
    payload: {
      id: id
    }
  };
}

function deleteStimulusEntry(id, childQuizEntryIds) {
  return {
    type: _quizCommon.DELETE_STIMULUS_ENTRY,
    payload: {
      id: id,
      childQuizEntryIds: childQuizEntryIds
    }
  };
}

function moveQuizEntry(id, position, stimulusQuizEntryId) {
  return {
    type: _quizCommon.MOVE_QUIZ_ENTRY,
    payload: {
      id: id,
      position: position,
      stimulusQuizEntryId: stimulusQuizEntryId
    }
  };
}