"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactImmutableProptypes = _interopRequireDefault(require("react-immutable-proptypes"));

var _partial = _interopRequireDefault(require("lodash/partial"));

var _immutable = require("immutable");

var _uiThemeable = require("@instructure/ui-themeable");

var _uiButtons = require("@instructure/ui-buttons");

var _uiElements = require("@instructure/ui-elements");

var _uiIcons = require("@instructure/ui-icons");

var _uiLayout = require("@instructure/ui-layout");

var _interactionTypeMetadata = require("../../../util/interactionTypeMetadata");

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _theme = _interopRequireDefault(require("./theme"));

var _dec, _class, _class2, _temp;

var styles = {
  componentId: 'bLlES',
  template: function template(theme) {
    return "\n\n.bLlES_cvRx{padding-right:0.25rem}\n\n.bLlES_dsOT{width:10rem}\n\n.bLlES_cFIX{border-top:".concat(theme.stimulusDividerBorderWidth || 'inherit', " solid ").concat(theme.stimulusDividerBorderColor || 'inherit', ";margin-bottom:").concat(theme.stimulusDividerMarginBottom || 'inherit', ";margin-top:").concat(theme.stimulusDividerMarginTop || 'inherit', "}");
  },
  'iconWrapper': 'bLlES_cvRx',
  'textWrapper': 'bLlES_dsOT',
  'stimulusDivider': 'bLlES_cFIX'
};
var InteractionTypes = (_dec = (0, _uiThemeable.themeable)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(InteractionTypes, _Component);

  function InteractionTypes() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, InteractionTypes);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(InteractionTypes)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.renderInteractionTypeButton = function (intType, i) {
      var onClick, Icon, name, title, automation;

      if (intType.name === 'Stimulus') {
        onClick = _this.props.addStimulus;
        Icon = _uiIcons.IconPlusLine;
        name = (0, _formatMessage.default)('Stimulus');
        title = (0, _formatMessage.default)('Add Stimulus');
        automation = 'sdk-interaction-button-stimulus';
      } else {
        onClick = (0, _partial.default)(_this.props.addItem, intType);
        var metadata = (0, _interactionTypeMetadata.interactionTypeMetadata)(intType);
        Icon = metadata.icon;
        name = metadata.name;
        title = (0, _formatMessage.default)('Add {name} Item', {
          name: name
        });
        automation = "sdk-interaction-button-".concat(intType.slug);
      }

      return _react.default.createElement(_uiButtons.Button, {
        fluidWidth: true,
        key: intType.slug,
        margin: "0 0 xx-small",
        onClick: onClick,
        size: "small",
        "data-automation": automation
      }, _react.default.createElement(_uiLayout.Grid, {
        colSpacing: "none",
        vAlign: "middle"
      }, _react.default.createElement(_uiLayout.Grid.Row, {
        key: "iconrow"
      }, _react.default.createElement(_uiLayout.Grid.Col, {
        width: "auto"
      }, _react.default.createElement("div", {
        className: styles.iconWrapper
      }, _react.default.createElement(Icon, {
        title: title
      }))), _react.default.createElement(_uiLayout.Grid.Col, null, _react.default.createElement("div", {
        className: styles.textWrapper
      }, _react.default.createElement(_uiElements.Text, {
        color: "primary"
      }, name))))));
    };

    _this.renderInteractionTypeRows = function () {
      var buttons = [];
      var types = _this.props.types; // The interaction types are in alphabetical order

      types.sortBy(function (intType) {
        return (0, _interactionTypeMetadata.interactionTypeMetadata)(intType).name;
      }).forEach(function (intType, i) {
        var button = _this.renderInteractionTypeButton(intType, i);

        if (i % _this.props.columns === 0) {
          buttons[Math.floor(i / _this.props.columns)] = [];
        }

        buttons[Math.floor(i / _this.props.columns)].push(_react.default.createElement(_uiLayout.Grid.Col, {
          width: 12 / _this.props.columns,
          key: intType.slug
        }, button));
      });
      return buttons.map(function (gridCols, i) {
        var key = gridCols.map(function (gridCol) {
          return gridCol.key;
        }).join('-');
        return _react.default.createElement(_uiLayout.Grid.Row, {
          key: key
        }, gridCols);
      });
    };

    _this.renderStimulusTypeButton = function () {
      if (_this.props.allowStimulusCreation) {
        var dividerRow = _react.default.createElement(_uiLayout.Grid.Row, {
          key: "divider"
        }, _react.default.createElement(_uiLayout.Grid.Col, {
          key: "divider"
        }, _react.default.createElement("div", {
          className: styles.stimulusDivider
        })));

        var stimulusRow = _react.default.createElement(_uiLayout.Grid.Row, {
          key: "stimulus"
        }, _react.default.createElement(_uiLayout.Grid.Col, {
          width: 12 / _this.props.columns,
          key: "stimulus"
        }, _this.renderInteractionTypeButton({
          name: 'Stimulus',
          slug: 'stimulus'
        })));

        return [dividerRow, stimulusRow];
      }
    };

    return _this;
  }

  (0, _createClass2.default)(InteractionTypes, [{
    key: "render",
    value: function render() {
      return _react.default.createElement(_uiLayout.Grid, {
        rowSpacing: "none",
        colSpacing: "small",
        startAt: "medium"
      }, this.renderInteractionTypeRows(), this.renderStimulusTypeButton());
    }
  }]);
  InteractionTypes.displayName = "InteractionTypes";
  return InteractionTypes;
}(_react.Component), _class2.propTypes = {
  columns: _propTypes.default.number.isRequired,
  addItem: _propTypes.default.func.isRequired,
  addStimulus: _propTypes.default.func.isRequired,
  allowStimulusCreation: _propTypes.default.bool,
  types: _reactImmutableProptypes.default.list
}, _class2.defaultProps = {
  allowStimulusCreation: true,
  types: (0, _immutable.List)()
}, _temp)) || _class);
exports.default = InteractionTypes;