"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _keyBy = _interopRequireDefault(require("lodash/keyBy"));

var _immutable = require("immutable");

var _quizCommon = require("@instructure/quiz-common");

var addShareBanks = function addShareBanks(state, sharedBank) {
  return state.mergeDeep((0, _immutable.fromJS)((0, _keyBy.default)(sharedBank, 'id')));
};

var _default = function _default() {
  var state = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : (0, _immutable.fromJS)({});
  var action = arguments.length > 1 ? arguments[1] : void 0;

  switch (action.type) {
    case _quizCommon.ADD_SHARED_BANKS:
      return addShareBanks(state, action.payload);

    case _quizCommon.REMOVE_SHARED_BANK:
      return state.remove(action.payload);

    default:
      return state;
  }
};

exports.default = _default;