"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mapStateToProps = mapStateToProps;
exports.default = exports.mapDispatchToProps = void 0;

var _stateHelper = _interopRequireDefault(require("../../../../common/util/stateHelper"));

var _reactRedux = require("../../../../common/react-redux");

var _quizCommon = require("@instructure/quiz-common");

var _quizSessions = require("../../../api/quizSessions");

var _moderation = require("../../../../common/actions/moderation");

var _presenter = _interopRequireDefault(require("./presenter"));

var _modal = require("../../../../common/actions/modal");

var _alerts = require("../../../../common/actions/alerts");

function mapStateToProps(state, ownProps) {
  var isFetching = state.getIn(['calls', _quizCommon.QUIZ_SESSIONS_FETCH_CALL, 'requestStatus']) === 'calling';
  var quiz_ids = ownProps.inProgressData.flatMap(function (user) {
    return user.quizSessionIds;
  });

  var quizSessionsData = _stateHelper.default.findQuizSessions(quiz_ids).filter(function (qs) {
    return qs.isLoaded() && !qs.pending();
  });

  var quizSessionIdsAndUsers = ownProps.inProgressData.flatMap(function (user) {
    return user.quizSessionIds.map(function (quiz_id) {
      return {
        name: user.name,
        id: quiz_id
      };
    });
  });
  return {
    isFetching: isFetching,
    quizSessionsData: quizSessionsData,
    quizSessionIdsAndUsers: quizSessionIdsAndUsers,
    hasSessionTimeLimit: state.getIn(['quizzes', ownProps.quizId, 'hasTimeLimit']),
    sessionTimeLimitInSeconds: state.getIn(['quizzes', ownProps.quizId, 'sessionTimeLimitInSeconds'])
  };
}

var mapDispatchToProps = {
  getQuizSessions: _quizSessions.getQuizSessions,
  openTray: _moderation.openTray,
  openModal: _modal.openModal,
  addSuccess: _alerts.addSuccess
};
exports.mapDispatchToProps = mapDispatchToProps;

var _default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(_presenter.default);

exports.default = _default;