"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _uiElements = require("@instructure/ui-elements");

var _uiLayout = require("@instructure/ui-layout");

var _uiA11y = require("@instructure/ui-a11y");

var _uiThemeable = require("@instructure/ui-themeable");

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _ModerateTableRow = _interopRequireDefault(require("../ModerateTableRow"));

var _IfFeature = _interopRequireDefault(require("../../../../common/components/shared/IfFeature"));

var _OutstandingQuizzesModal = _interopRequireDefault(require("../OutstandingQuizzesModal"));

var _ModerateTray = _interopRequireDefault(require("../../sidebar/ModerateTray"));

var _Spinner = _interopRequireDefault(require("../../../../common/components/shared/spinner/Spinner"));

var _theme = _interopRequireDefault(require("./theme"));

var _ResetQuiz = _interopRequireDefault(require("../../sidebar/ResetQuiz"));

var _quizCommon = require("@instructure/quiz-common");

var _uiIcons = require("@instructure/ui-icons");

var _dec, _class, _class2, _temp;

var styles = {
  componentId: 'esFtE',
  template: function template(theme) {
    return "\n\n.esFtE_bwKH{display:block;margin:".concat(theme.emptyTextMargin || 'inherit', " 0 0 0}\n\n.esFtE_xNcP{background-color:").concat(theme.pageBackgroundColor || 'inherit', ";flex:1;overflow:auto}");
  },
  'emptyText': 'esFtE_bwKH',
  'page': 'esFtE_xNcP'
};

var _ref2 =
/*#__PURE__*/
_react.default.createElement(_uiLayout.Flex.Item, null, _react.default.createElement(_uiIcons.IconInfoLine, null));

var _ref4 =
/*#__PURE__*/
_react.default.createElement(_Spinner.default, null);

var _ref5 =
/*#__PURE__*/
_react.default.createElement(_ResetQuiz.default, null);

var ModerateTable = (_dec = (0, _uiThemeable.themeable)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(ModerateTable, _Component);

  function ModerateTable() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, ModerateTable);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(ModerateTable)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.state = {
      //To support voiceover when the table changes
      moderatePanelIterations: 0,
      selectedStudent: null,
      //To display the spinner while manually submitted quiz sessions are being graded
      isWaiting: false
    };

    _this.fetchData = function () {
      var _this$props = _this.props,
          getQuizSessions = _this$props.getQuizSessions,
          quizId = _this$props.quizId,
          inProgressData = _this$props.inProgressData,
          tableData = _this$props.tableData;
      var quizSessionIds = (0, _toConsumableArray2.default)(new Set([].concat((0, _toConsumableArray2.default)(_this.quizSessionIds(inProgressData)), (0, _toConsumableArray2.default)(_this.quizSessionIds(tableData))))); // NOTE: The consumer provided no quizSessionIds. Don't fetch

      if (!quizSessionIds.length) return;
      getQuizSessions(quizId, {
        ids: quizSessionIds
      });
    };

    _this.onModerateButtonClick = function (data) {
      _this.setState({
        selectedStudent: data.id
      });

      _this.props.onOpenTray(data);

      _this.props.openTray(data);
    };

    _this.onCloseTray = function () {
      _this.props.onCloseTray();

      _this.setState({
        moderatePanelIterations: _this.state.moderatePanelIterations + 1
      });
    };

    _this.sessionsStillAutograding = function (quizzesToSubmit) {
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;

      var _iteratorError = void 0;

      try {
        for (var _iterator = _this.props.quizSessionsData[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var quizSession = _step.value;

          if (quizzesToSubmit.indexOf(quizSession.id) > -1 && (quizSession.status === 'autograding' || quizSession.status === 'in_progress')) {
            return true;
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return != null) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return false;
    };

    _this.checkAutogradingStatus = function (submittedQuizSessions) {
      if (_this.sessionsStillAutograding(submittedQuizSessions)) {
        _this.pollAutogradingStatus(submittedQuizSessions);
      } else {
        _this.setState({
          isWaiting: false
        });

        _this.props.addSuccess((0, _formatMessage.default)('Manual submission was successful.'));
      }
    };

    _this.pollAutogradingStatus = function (submittedQuizSessions) {
      _this.fetchData();

      setTimeout(function () {
        _this.checkAutogradingStatus(submittedQuizSessions);
      }, 1000);
    };

    _this.handleSubmissionAndPoll = function (submittedQuizSessions) {
      _this.setState({
        isWaiting: true
      });

      _this.pollAutogradingStatus(submittedQuizSessions);
    };

    _this.openModalOnClick = function () {
      _this.props.openModal(_quizCommon.OUTSTANDING_QUIZZES_MODAL);
    };

    return _this;
  }

  (0, _createClass2.default)(ModerateTable, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.fetchData();
      var _this$props2 = this.props,
          hasSessionTimeLimit = _this$props2.hasSessionTimeLimit,
          sessionTimeLimitInSeconds = _this$props2.sessionTimeLimitInSeconds;
      this.props.sendSessionTimeLimit({
        hasSessionTimeLimit: hasSessionTimeLimit,
        sessionTimeLimitInSeconds: sessionTimeLimitInSeconds
      });
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this$props3 = this.props,
          hasSessionTimeLimit = _this$props3.hasSessionTimeLimit,
          sessionTimeLimitInSeconds = _this$props3.sessionTimeLimitInSeconds;

      if (prevProps.hasSessionTimeLimit !== hasSessionTimeLimit || prevProps.sessionTimeLimitInSeconds !== sessionTimeLimitInSeconds) {
        this.props.sendSessionTimeLimit({
          hasSessionTimeLimit: hasSessionTimeLimit,
          sessionTimeLimitInSeconds: sessionTimeLimitInSeconds
        });
      }

      if (prevProps.tableData != this.props.tableData) {
        this.setState({
          selectedStudent: null
        });
      }

      var quizSessionIds = (0, _toConsumableArray2.default)(new Set([].concat((0, _toConsumableArray2.default)(this.quizSessionIds(this.props.inProgressData)), (0, _toConsumableArray2.default)(this.quizSessionIds(this.props.tableData)))));
      var prevQuizSessionIds = (0, _toConsumableArray2.default)(new Set([].concat((0, _toConsumableArray2.default)(this.quizSessionIds(prevProps.inProgressData)), (0, _toConsumableArray2.default)(this.quizSessionIds(prevProps.tableData)))));
      var skipFetchData = quizSessionIds.every(function (id, index) {
        return id === prevQuizSessionIds[index];
      });
      if (skipFetchData) return;
      this.fetchData();
    }
  }, {
    key: "quizSessionIds",
    value: function quizSessionIds(data) {
      return data.reduce(function (ids, _ref) {
        var quizSessionIds = _ref.quizSessionIds;
        return ids.concat(quizSessionIds);
      }, []).sort();
    }
  }, {
    key: "renderTableRows",
    // =============
    //   RENDERING
    // =============
    value: function renderTableRows() {
      var _this2 = this;

      var _this$props4 = this.props,
          onModerateLogClick = _this$props4.onModerateLogClick,
          onResultsLinkClick = _this$props4.onResultsLinkClick,
          shouldRenderModerateButton = _this$props4.shouldRenderModerateButton;
      return this.props.tableData.map(function (rowData) {
        var id = rowData.id;
        return _react.default.createElement(_ModerateTableRow.default, {
          onResultsLinkClick: onResultsLinkClick,
          onAccommodationsClick: _this2.props.onAccommodationsClick,
          key: "".concat(id, "-").concat(_this2.state.moderatePanelIterations) // eslint-disable-line react/jsx-no-literals
          ,
          onModerateButtonClick: _this2.onModerateButtonClick,
          onModerateLogClick: onModerateLogClick,
          rowData: rowData,
          shouldRenderModerateButton: shouldRenderModerateButton,
          focusTarget: _this2.state.selectedStudent
        });
      });
    }
  }, {
    key: "countOutstandingAttempts",
    value: function countOutstandingAttempts() {
      var i = 0;

      if (!this.props.quizSessionsData) {
        return 0;
      }

      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;

      var _iteratorError2 = void 0;

      try {
        for (var _iterator2 = this.props.quizSessionsData[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var quiz = _step2.value;

          if (quiz.status === 'in_progress') {
            i += 1;
          }
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      return i;
    }
  }, {
    key: "renderAlertContent",
    value: function renderAlertContent(outstandingAttemptsCount) {
      var _this3 = this;

      return _react.default.createElement("div", null, _react.default.createElement(_IfFeature.default, {
        name: "manual_submission"
      }, _react.default.createElement(_uiLayout.Flex, null, _ref2, _react.default.createElement(_uiLayout.Flex.Item, {
        padding: "xx-small"
      }, _formatMessage.default.rich('This assessment has <0>{count, plural, one {# attempt} other {# attempts}}</0> in progress.', {
        count: outstandingAttemptsCount,
        0: function _(_ref3) {
          var children = _ref3.children;
          return _react.default.createElement(_uiElements.Link, {
            key: "0",
            onClick: _this3.openModalOnClick,
            "data-automation": "sdk-outstanding-quizzes-modal-open"
          }, children);
        }
      })))), _react.default.createElement(_IfFeature.default, {
        name: "manual_submission"
      }, _react.default.createElement(_OutstandingQuizzesModal.default, {
        quizSessionsData: this.props.quizSessionsData,
        quizSessionIdsAndUsers: this.props.quizSessionIdsAndUsers,
        handleSubmissionAndPoll: this.handleSubmissionAndPoll,
        afterSubmit: this.props.afterManualSubmit
      })));
    }
  }, {
    key: "renderTable",
    value: function renderTable() {
      var outstandingAttemptsCount = this.countOutstandingAttempts();
      return _react.default.createElement("div", null, outstandingAttemptsCount ? this.renderAlertContent(outstandingAttemptsCount) : null, _react.default.createElement(_uiElements.Table, {
        caption: _react.default.createElement(_uiA11y.ScreenReaderContent, null, (0, _formatMessage.default)('Moderation Table'))
      }, _react.default.createElement("thead", null, _react.default.createElement("tr", null, _react.default.createElement("th", null, (0, _formatMessage.default)('Student')), _react.default.createElement("th", null, (0, _formatMessage.default)('Attempts')), _react.default.createElement("th", null, (0, _formatMessage.default)('Score')), _react.default.createElement("th", null, (0, _formatMessage.default)('Time')), _react.default.createElement("th", null, (0, _formatMessage.default)('Log')), this.props.onAccommodationsClick && _react.default.createElement("th", null, (0, _formatMessage.default)({
        default: 'Accommodations',
        description: 'Support for students with who need extra time or attempts.'
      })), this.props.shouldRenderModerateButton && _react.default.createElement("th", null, _react.default.createElement(_uiA11y.ScreenReaderContent, null, (0, _formatMessage.default)('Moderate'))))), _react.default.createElement("tbody", null, this.renderTableRows())));
    }
  }, {
    key: "renderContent",
    value: function renderContent() {
      var _this$props5 = this.props,
          isFetching = _this$props5.isFetching,
          tableData = _this$props5.tableData,
          emptyMessage = _this$props5.emptyMessage;
      if (isFetching || this.state.isWaiting) return _ref4;
      if (tableData.length) return this.renderTable();
      return _react.default.createElement("span", {
        className: styles.emptyText
      }, _react.default.createElement(_uiElements.Text, {
        color: "primary"
      }, emptyMessage));
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement("div", {
        className: styles.page
      }, _react.default.createElement(_ModerateTray.default, {
        onClose: this.onCloseTray
      }, _ref5, this.props.children), this.renderContent());
    }
  }]);
  ModerateTable.displayName = "ModerateTable";
  return ModerateTable;
}(_react.Component), _class2.propTypes = {
  children: _propTypes.default.node,
  emptyMessage: _propTypes.default.string,
  isFetching: _propTypes.default.bool.isRequired,
  onCloseTray: _propTypes.default.func,
  onModerateLogClick: _propTypes.default.func.isRequired,
  onAccommodationsClick: _propTypes.default.func,
  onOpenTray: _propTypes.default.func,
  onResultsLinkClick: _propTypes.default.func,
  openTray: _propTypes.default.func.isRequired,
  sessionTimeLimitInSeconds: _propTypes.default.number,
  hasSessionTimeLimit: _propTypes.default.bool,
  sendSessionTimeLimit: _propTypes.default.func,
  shouldRenderModerateButton: _propTypes.default.bool,
  openModal: _propTypes.default.func.isRequired,
  quizSessionIdsAndUsers: _propTypes.default.arrayOf(_propTypes.default.shape({
    id: _propTypes.default.string,
    name: _propTypes.default.string
  })),
  quizSessionsData: _propTypes.default.arrayOf(_propTypes.default.shape({
    id: _propTypes.default.string.isRequired,
    name: _propTypes.default.string.isRequired,
    status: _propTypes.default.string.isRequired
  })).isRequired,
  afterManualSubmit: _propTypes.default.func,
  inProgressData: _propTypes.default.arrayOf(_propTypes.default.shape({
    avatar: _propTypes.default.string,
    id: _propTypes.default.string.isRequired,
    name: _propTypes.default.string.isRequired,
    quizSessionIds: _propTypes.default.arrayOf(_propTypes.default.string).isRequired,
    maxAttempts: _propTypes.default.number,
    accommodations: _propTypes.default.arrayOf(_propTypes.default.shape({
      name: _propTypes.default.string.isRequired,
      value: _propTypes.default.string.isRequired
    }))
  })).isRequired,
  tableData: _propTypes.default.arrayOf(_propTypes.default.shape({
    avatar: _propTypes.default.string,
    id: _propTypes.default.string.isRequired,
    name: _propTypes.default.string.isRequired,
    quizSessionIds: _propTypes.default.arrayOf(_propTypes.default.string).isRequired,
    maxAttempts: _propTypes.default.number,
    accommodations: _propTypes.default.arrayOf(_propTypes.default.shape({
      name: _propTypes.default.string.isRequired,
      value: _propTypes.default.string.isRequired
    }))
  })).isRequired,
  quizId: _propTypes.default.number.isRequired,
  getQuizSessions: _propTypes.default.func.isRequired,
  addSuccess: _propTypes.default.func.isRequired
}, _class2.defaultProps = {
  children: void 0,
  emptyMessage: (0, _formatMessage.default)('There is no moderation information to display yet.'),
  onCloseTray: Function.prototype,
  onOpenTray: Function.prototype,
  sendSessionTimeLimit: Function.prototype,
  sessionTimeLimitInSeconds: null,
  hasSessionTimeLimit: false,
  shouldRenderModerateButton: true,
  onAccommodationsClick: null,
  onOutstandingQuizzesClick: void 0,
  onResultsLinkClick: void 0,
  quizSessionIdsAndUsers: [],
  afterManualSubmit: Function.prototype
}, _temp)) || _class);
exports.default = ModerateTable;